Imports System
Imports System.IO

Friend Class Program
	Public Sub New()
		MyBase.New()
	End Sub

	Public Shared Sub Main(ByVal args As String())
		Console.WriteLine("Enter the filename and extension:")
		Dim fileName As String = Console.ReadLine()
		Console.BackgroundColor = ConsoleColor.DarkBlue
		Console.ForegroundColor = ConsoleColor.White
		Console.Clear()
		Try
			Dim lines As String() = File.ReadAllLines(fileName)
			Dim lineCount As Integer = CInt(lines.Length)
			Dim linePtr As Integer = 0
			Dim pageSize As Integer = 24
			Dim quitFlag As Boolean = False
			While Not quitFlag
				Console.BackgroundColor = ConsoleColor.Cyan
				Console.ForegroundColor = ConsoleColor.Black
				Console.CursorLeft = 0
				Console.CursorTop = 0
				Console.WriteLine(String.Format("Line: {0}  File: {1}  Quit: Escape ", linePtr + 1, fileName))
				Console.BackgroundColor = ConsoleColor.DarkBlue
				Console.ForegroundColor = ConsoleColor.White
				Dim i As Integer = linePtr
				While True
					If (If(i >= linePtr + pageSize, True, i >= lineCount)) Then
						Exit While
					End If
					Console.WriteLine(lines(i) + Microsoft.VisualBasic.Space(80 - lines(i).Length))
					i = i + 1
				End While
				While Console.KeyAvailable
					Console.ReadKey(False)
				End While
				Dim key As ConsoleKey = Console.ReadKey().Key
				If (key = ConsoleKey.Escape) Then
					quitFlag = True
				Else
					Select Case key
						Case ConsoleKey.PageUp
							If (linePtr > 0) Then
								linePtr -= pageSize
								If (linePtr < 0) Then
									linePtr = 0
								End If
							End If
							Exit Select
						Case ConsoleKey.PageDown
							If (linePtr < lineCount - pageSize) Then
								linePtr += pageSize
								If (linePtr > lineCount - pageSize) Then
									linePtr = lineCount - pageSize
								End If
							End If
							Exit Select
						Case ConsoleKey.[End]
							linePtr = lineCount - pageSize
							Exit Select
						Case ConsoleKey.Home
							linePtr = 0
							Exit Select
						Case ConsoleKey.UpArrow
							If (linePtr > 0) Then
								linePtr = linePtr - 1
							End If
							Exit Select
						Case ConsoleKey.DownArrow
							If (linePtr < lineCount - pageSize) Then
								linePtr = linePtr + 1
							End If
							Exit Select
					End Select
				End If
			End While
		Catch fileNotFoundException As System.IO.FileNotFoundException
			Console.WriteLine("File not found.")
		Catch exception As System.Exception
			Console.WriteLine(String.Concat("An error occurred: ", exception.Message))
		End Try
	End Sub
End Class